/* $Id: cctenv.c,v 1.1 2006/04/28 09:04:28 zlb Exp $ */

/* The program sets the environment variables CCTINSTPATH, CCTTEXMF, and
 * CCTLOCALTEXMF using the first three command-line arguments, then
 * executes the program given by the fourth argument */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>

static char buffer[2048];
const char *args[] = {NULL};

static char *
remove_quotes(const char *old)
/* copy argument 'old' to 'new', deleting double quotes */
{
    char *p;
    const char *q;

    for (p = buffer, q = old; *q != '\0';) {
	if (*q == '"') {
	    q++;
	    continue;
	}
	*(p++) = *(q++);
    }
    *p = '\0';

    return buffer;
}

static void
setenv(const char *name, const char *value, int overwrite)
{
    char tmp[2100];

    (void)overwrite;
    sprintf(tmp, "%s=%s", name, value);
    putenv(tmp);
}

int
main(int argc, char *argv[])
{
    if (argc != 5) {
	fprintf(stderr, "Usage: %s path texmf localtexmf progname\n", argv[0]);
	return 1;
    }

    setenv("CCTINSTPATH",   remove_quotes(argv[1]), 1);
    setenv("CCTTEXMF",	    remove_quotes(argv[2]), 1);
    setenv("CCTLOCALTEXMF", remove_quotes(argv[3]), 1);

    _spawnvp(P_WAIT, argv[4], args);

    return 0;
}
